=== debian/changelog ===
ros-indigo-mvsim (0.1.2-0trusty) trusty; urgency=high

  * Cleaner build against mrpt 1.3.0
  * Fix build against mrpt 1.3.0
  * Contributors: Jose Luis Blanco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sat, 23 May 2015 22:00:00 -0000

ros-indigo-mvsim (0.1.1-0trusty) trusty; urgency=high

  * First public release.
  * Contributors: Jose Luis Blanco

 -- Jose-Luis Blanco-Claraco <jlblanco@ual.es>  Sat, 27 Dec 2014 23:00:00 -0000
